define(['require', 'https://d3js.org/d3.v5.min.js'], function (requirejs, d3) { 'use strict';

  function _typeof(obj) {
    "@babel/helpers - typeof";

    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
          result;

      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;

        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }

      return _possibleConstructorReturn(this, result);
    };
  }

  var e = function () {
    function t(t, e) {
      this.name = t, this.slot = e || null, this.attributes = new Map();
    }

    return t.prototype.getName = function () {
      return this.name;
    }, t.prototype.getSlot = function () {
      return this.slot;
    }, t.prototype.getAttributes = function () {
      return this.attributes;
    }, t.slotLimit = function (e, n) {
      return new t("limit", e).attr("n", n);
    }, t.dataLimit = function (e) {
      return new t("limit").attr("n", e);
    }, t.prototype.attr = function (t, e) {
      return this.attributes.set(t, e), this;
    }, t;
  }(),
      _n = function n(t, e) {
    return (_n = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (t, e) {
      t.__proto__ = e;
    } || function (t, e) {
      for (var n in e) {
        Object.prototype.hasOwnProperty.call(e, n) && (t[n] = e[n]);
      }
    })(t, e);
  };
  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */


  function r(t, e) {
    function r() {
      this.constructor = t;
    }

    _n(t, e), t.prototype = null === e ? Object.create(e) : (r.prototype = e.prototype, new r());
  }

  function o(t, e, n) {
    return t.getDecoration(e, n);
  }

  function i(t) {
    return t.hasDecoration("hasSelection") ? o(t, "hasSelection", !1) : !!function (t) {
      return "getSlot" in t && "hasDecorationOnDataPoints" in t;
    }(t) && t.hasDecorationOnDataPoints("selected");
  }

  var u,
      s = function () {
    function t(t, e) {
      this.min = t, this.max = e;
    }

    return t.prototype.asArray = function () {
      return [this.min, this.max];
    }, t.empty = new t(0, 0), t;
  }(),
      a = function (t) {
    function e(e, n) {
      return t.call(this, e, n) || this;
    }

    return r(e, t), e.fromRS = function (t) {
      return new s(t.min, t.max);
    }, e;
  }(s),
      l = function () {
    function t(t, e) {
      this.source = t, this.index = e, this.key = t.getKey(!1), this.caption = t.getCaption("label") || "";
      var n = t.getItems() || [];
      this.segments = n.map(function (t) {
        return new p(t);
      });
    }

    return Object.defineProperty(t.prototype, "selected", {
      get: function get() {
        return o(this.source, "selected", !1);
      },
      enumerable: !1,
      configurable: !0
    }), Object.defineProperty(t.prototype, "highlighted", {
      get: function get() {
        return o(this.source, "highlighted", !1);
      },
      enumerable: !1,
      configurable: !0
    }), t;
  }(),
      c = function (t) {
    function e(e, n) {
      return t.call(this, e, n) || this;
    }

    return r(e, t), e;
  }(l),
      h = function () {
    function t(t) {
      this.source = t, this.key = this.source.getUniqueName() || "", this.caption = this.source.getCaption("label") || "";
    }

    return Object.defineProperty(t.prototype, "selected", {
      get: function get() {
        return o(this.source, "selected", !1);
      },
      enumerable: !1,
      configurable: !0
    }), Object.defineProperty(t.prototype, "highlighted", {
      get: function get() {
        return o(this.source, "highlighted", !1);
      },
      enumerable: !1,
      configurable: !0
    }), t;
  }(),
      p = function (t) {
    function e(e) {
      return t.call(this, e) || this;
    }

    return r(e, t), e;
  }(h),
      f = new (function () {
    function t() {}

    return t.prototype.format = function (t) {
      return t ? t.toString() : "";
    }, t;
  }())();

  !function (t) {
    t.label = "label", t.data = "data";
  }(u || (u = {}));

  var g = function () {
    function t(t, e, n, r, o) {
      this.source = t, this.tuples = e, this.segments = n, this.domain = r, this.caption = o;
      var i = t.dataItems || [],
          u = i.length > 0 ? i[0] : null,
          s = u && u.asCont();
      s ? (this._labelFormatter = s.getFormatter("label") || f, this._dataFormatter = s.getFormatter("data") || f) : this._labelFormatter = this._dataFormatter = f;
    }

    return Object.defineProperty(t.prototype, "mapped", {
      get: function get() {
        return this.source.mapped;
      },
      enumerable: !1,
      configurable: !0
    }), Object.defineProperty(t.prototype, "dataType", {
      get: function get() {
        var t = this.source.getDataItem(0);
        return this.mapped && t ? t.type : "none";
      },
      enumerable: !1,
      configurable: !0
    }), t.prototype.format = function (t, e) {
      return function (t, e) {
        return t.format(e);
      }(e === u.data ? this._dataFormatter : this._labelFormatter, t);
    }, t;
  }(),
      d = function (t) {
    function e(e, n, r, o, i) {
      return t.call(this, e, n, r, o, i) || this;
    }

    return r(e, t), e;
  }(g),
      m = function () {
    function t(t, e) {
      this.source = t, this.key = t.getKey(!1), this.dataSet = e;
    }

    return Object.defineProperty(t.prototype, "selected", {
      get: function get() {
        return o(this.source, "selected", !1);
      },
      enumerable: !1,
      configurable: !0
    }), Object.defineProperty(t.prototype, "highlighted", {
      get: function get() {
        return o(this.source, "highlighted", !1);
      },
      enumerable: !1,
      configurable: !0
    }), t.prototype.tuple = function (t) {
      var e = this._getSlot(t);

      if (!e || 0 === e.tuples.length) return null;
      var n = this.source.get(e.source);
      if (!n) return null;
      var r = n.asCat();
      return r ? e.tuples[r.index] : null;
    }, t.prototype.value = function (t) {
      var e = this._getSlot(t),
          n = e && this.source.get(e.source);

      if (!n) return null;
      var r = n.asCont();
      return r && "numeric" === r.valueType ? r.value : null;
    }, t.prototype.caption = function (t) {
      var e = this._getSlot(t),
          n = e && this.source.get(e.source);

      return n && n.getCaption("data") || "";
    }, t.prototype._getSlot = function (t) {
      return "string" == typeof t ? this.dataSet.slotMap.get(t) || null : this.dataSet.cols[t] || null;
    }, t;
  }(),
      y = function (t) {
    function e(e, n) {
      return t.call(this, e, n) || this;
    }

    return r(e, t), e;
  }(m),
      v = function () {
    function t(t, e, n) {
      var r = this;
      this.source = t, this.rows = t.dataPoints.map(function (t) {
        return new y(t, r);
      }), this.cols = e, this.slotMap = n;
    }

    return t.filterRows = function (t, e, n) {
      return t.filter(function (t) {
        var r = t.tuple(e);
        return !!r && r.key === n;
      });
    }, Object.defineProperty(t.prototype, "hasSelections", {
      get: function get() {
        return i(this.source);
      },
      enumerable: !1,
      configurable: !0
    }), t;
  }(),
      _ = function (t) {
    function e(e, n, r) {
      return t.call(this, e, n, r) || this;
    }

    return r(e, t), e;
  }(v);

  function b(t) {
    var e = new Map(),
        n = t.getSlots().map(function (t, n) {
      var r = [],
          o = [],
          i = s.empty,
          u = "";

      if (t.isMapped()) {
        var l = t.getDataItem(0);
        if (u = l.getCaption("label"), "cat" === l.getRSType()) r = l.getTuples().map(function (t, e) {
          return new c(t, e);
        }), o = l.getItemClassSet(0).getItemClasses().map(function (t) {
          return new p(t);
        });else i = a.fromRS(l.getDomain()), o.push(new p(l.getItemClass()));
      }

      var h = new d(t, r, o, i, u);
      return e.set(t.name, h), h;
    });
    return new _(t, n, e);
  }

  function w(t) {
    return t < 0 ? 0 : t > 255 ? 255 : Math.floor(t);
  }

  var C = function () {
    function t(t, e, n, r) {
      var o;
      this.r = w(t), this.g = w(e), this.b = w(n), this.a = (o = r) < 0 ? 0 : o > 1 ? 1 : o;
    }

    return t.fromObject = function (e) {
      return new t(e.r, e.g, e.b, void 0 === e.a ? 1 : e.a);
    }, t.prototype.toString = function () {
      return 1 === this.a ? "rgb(" + this.r + "," + this.g + "," + this.b + ")" : "rgba(" + this.r + "," + this.g + "," + this.b + "," + this.a + ")";
    }, t;
  }();

  function S(t, e) {
    var n = null;
    if (t instanceof m) n = t.source.getDataSet(e);else {
      var r = t.source.getDataItem(e);
      n = r && r.getDataSet(e);
    }
    return !!n && i(n);
  }

  var P = function P(t) {
    return "rgba(" + t.r + "," + t.g + "," + t.b + ",0.4)";
  },
      j = function j(t) {
    return "rgba(" + Math.round(.7 * t.r) + "," + Math.round(.7 * t.g) + "," + Math.round(.7 * t.b) + "," + t.a + ")";
  },
      O = function () {
    function t(t, e, n) {
      this.source = t, this._dataContext = e, this._slotResolver = n;
    }

    return Object.defineProperty(t.prototype, "slot", {
      get: function get() {
        return this.source.slot;
      },
      enumerable: !1,
      configurable: !0
    }), t.prototype.getColor = function (t) {
      return t ? C.fromObject(this.source.getTupleColor(t.source, -1)) : C.fromObject(this.source.getColor(null));
    }, t.prototype._getTuple = function (t) {
      if (t instanceof l) return t;

      var e = this.slot || this._slotResolver(t.dataSet, this.source.name);

      return e ? t.tuple(e) : null;
    }, t.prototype.getFillColor = function (t) {
      if (null === t) return this.source.getColor(null).toString();

      var e,
          n = this._getTuple(t);

      return e = n ? this.source.getTupleColor(n.source, -1) : this.source.getColor(t.source), !t.selected && S(t, this._dataContext) ? P(e) : e.toString();
    }, t.prototype.getOutlineColor = function (t) {
      if (null === t) return this.source.getColor(null).toString();

      var e,
          n = this._getTuple(t);

      return e = n ? this.source.getTupleColor(n.source, -1) : this.source.getColor(t.source), t.highlighted || t.selected && S(t, this._dataContext) ? j(e) : null;
    }, t;
  }(),
      x = function x(t, e, n) {
    this.color = t, this.at = e, this.value = n;
  };

  function I(t) {
    return t.map(function (t) {
      return new x(C.fromObject(t.color), t.at, t.value);
    });
  }

  var D = function () {
    function t(t, e, n) {
      this.source = t, this._slot = e, this._dataContext = n, this.stops = I(t.stops), this.aligned = I(t.aligned), this.interpolate = t.interpolate;
    }

    return t.prototype.getColor = function (t) {
      return C.fromObject(this.source.getColor(t));
    }, t.prototype.getFillColor = function (t) {
      var e = this._slot ? Number(t.value(this._slot)) : 0,
          n = this.source.getColor(e);
      return !t.selected && S(t, this._dataContext) ? P(n) : n.toString();
    }, t.prototype.getOutlineColor = function (t) {
      var e = this._slot ? Number(t.value(this._slot)) : 0,
          n = this.source.getColor(e);
      return t.highlighted || t.selected && S(t, this._dataContext) ? j(n) : null;
    }, t;
  }(),
      E = function () {
    function t(t, e, n) {
      this.source = t, this._dataContext = e, this._lastDataItem = null, this._cachedStops = null, this._slotResolver = n;
    }

    return Object.defineProperty(t.prototype, "slot", {
      get: function get() {
        return this.source.slot;
      },
      enumerable: !1,
      configurable: !0
    }), t.prototype.getColorStops = function (t) {
      var e = t ? t.source.getDataItem(0) : null,
          n = e && e.asCont(),
          r = n ? n.getDomain(null) : null,
          o = this.source.getColorStops(n, r),
          i = t ? t.source.name : null;
      return new D(o, i, this._dataContext);
    }, t.prototype._fetchColorStops = function (t) {
      var e = t.source.getDataSet(this._dataContext),
          n = this.slot || this._slotResolver(t.dataSet, this.source.name),
          r = n ? e.getSlot(n) : null,
          o = r ? r.getDataItem(0) : null,
          i = o ? o.asCont() : null;

      if (this.source.dirty || !this._cachedStops || i !== this._lastDataItem) {
        var u = i ? i.getDomain(null) : null,
            s = this.source.getColorStops(i, u);
        this._cachedStops = new D(s, r && r.name, this._dataContext), this._lastDataItem = i;
      }

      return this._cachedStops;
    }, t.prototype.getFillColor = function (t) {
      return this._fetchColorStops(t).getFillColor(t);
    }, t.prototype.getOutlineColor = function (t) {
      return this._fetchColorStops(t).getOutlineColor(t);
    }, t;
  }(),
      T = function (t) {
    function e(e) {
      var n = t.call(this, e.r, e.g, e.b, e.a) || this;
      return n._color = e, n;
    }

    return r(e, t), e.prototype.getRed = function () {
      return this.r;
    }, e.prototype.getGreen = function () {
      return this.g;
    }, e.prototype.getBlue = function () {
      return this.b;
    }, e.prototype.getAlpha = function () {
      return this.a;
    }, e;
  }(C),
      R = Object.freeze({
    min: 0,
    max: 0,
    empty: !0,
    explicit: !1,
    getMin: function getMin() {
      return 0;
    },
    getMax: function getMax() {
      return 0;
    },
    isEmpty: function isEmpty() {
      return !0;
    },
    isExplicit: function isExplicit() {
      return !1;
    }
  }),
      F = function () {
    function t(t, e, n, r, o, i) {
      this.caption = t, this.color = e, this.shape = n, this.selected = r, this.highlighted = o, this.ref = i;
    }

    return t.prototype.getCaption = function () {
      return this.caption;
    }, t.prototype.getColor = function () {
      return this.color ? new T(this.color) : null;
    }, t.prototype.getShape = function () {
      return this.shape;
    }, t.prototype.isSelected = function () {
      return this.selected;
    }, t.prototype.isHighlighted = function () {
      return this.highlighted;
    }, t.prototype.getRef = function () {
      return this.ref;
    }, t;
  }(),
      M = function () {
    function t(t, e, n, r, o, i) {
      this.type = t, this.channel = e, this.slot = n, this.caption = r, this.subCaption = o, this.ref = i;
    }

    return t.prototype.getRSType = function () {
      return this.type;
    }, t.prototype.getChannel = function () {
      return this.channel;
    }, t.prototype.getSlot = function () {
      return this.slot;
    }, t.prototype.getCaption = function () {
      return this.caption;
    }, t.prototype.getSubCaption = function () {
      return this.subCaption;
    }, t.prototype.getRef = function () {
      return this.ref;
    }, t;
  }(),
      L = function (t) {
    function e(e, n, r, i, u) {
      var s = this,
          a = n && n.source,
          l = a && a.name,
          c = a && a.getDataItem(0),
          h = c && c.asCat();
      s = t.call(this, "cat", e, l, r, "", h) || this;
      var p = h ? h.tuples : [];
      return s.entries = p.map(function (t) {
        var e = t.getCaption("label") || "",
            n = u && u.source.getTupleColor(t, -1),
            r = o(t, "selected", !1),
            s = o(t, "highlighted", !1);
        return new F(e, n ? C.fromObject(n) : null, i, r, s, t);
      }), s;
    }

    return r(e, t), e.prototype.getEntries = function () {
      return this.entries;
    }, e;
  }(M),
      A = function (t) {
    function e(e, n, r, o) {
      var i = this,
          u = n && n.source,
          s = u && u.name,
          a = u && u.getDataItem(0),
          l = a && a.asCont();

      if ((i = t.call(this, "cont", e, s, r, "", l) || this).domain = l ? l.getDomain(null) : R, o && "color" === e) {
        var c = o.source.getColorStops(l, null);
        i.stops = c.stops, i.interpolate = c.interpolate;
      } else i.stops = null, i.interpolate = !1;

      return i;
    }

    return r(e, t), e.prototype.getDomain = function () {
      return this.domain;
    }, e.prototype.getInterpolate = function () {
      return this.interpolate;
    }, e.prototype.getStops = function () {
      return this.stops;
    }, e;
  }(M);

  function z(t, e, n, r) {
    if (!t) return [];
    var o = new Map(),
        i = new Map();
    e.palettes.forEach(function (e) {
      var n = e.slot || r && r(t, e.source.name);
      n && (e instanceof O ? o.set(n, e) : e instanceof E && i.set(n, e));
    });
    var u = [];
    return t.cols.forEach(function (t) {
      var e = t.source;

      if (e.mapped) {
        var r = e.getDataItem(0);
        if (r) switch (r.type) {
          case "cat":
            if (-1 === e.channels.indexOf("color")) return;
            var s = o.get(e.name);
            s && u.push(new L("color", t, t.caption, n.legendShape, s));
            break;

          case "cont":
            if (-1 !== e.channels.indexOf("color")) {
              var a = i.get(e.name);
              a && u.push(new A("color", t, t.caption, a));
            }

            -1 !== e.channels.indexOf("size") && u.push(new A("size", t, t.caption, null));
        }
      }
    }), u;
  }

  var N,
      k = function k() {
    this.legendShape = null, this.slotLimits = new Map(), this.dataLimit = -1;
  };

  !function (t) {
    t.Em = "em", t.Percentage = "%", t.Centimeter = "cm", t.Millimeter = "mm", t.Inch = "in", t.Pica = "pc", t.Point = "pt", t.Pixel = "px";
  }(N || (N = {}));

  var H,
      U,
      V = function () {
    function t(t, e) {
      this.value = t, this.unit = e;
    }

    return t.fromObject = function (e) {
      return new t(e.value, function (t) {
        switch (t) {
          case "em":
            return N.Em;

          case "%":
            return N.Percentage;

          case "cm":
            return N.Centimeter;

          case "mm":
            return N.Millimeter;

          case "in":
            return N.Inch;

          case "pc":
            return N.Pica;

          case "pt":
            return N.Point;

          case "px":
            return N.Pixel;

          default:
            throw new Error("Invalid length unit '" + t + "' specified");
        }
      }(e.unit));
    }, t.prototype.toString = function () {
      return "" + this.value + this.unit;
    }, t;
  }();

  !function (t) {
    t.Normal = "normal", t.Italic = "italic";
  }(H || (H = {})), function (t) {
    t[t.Thin = 100] = "Thin", t[t.ExtraLight = 200] = "ExtraLight", t[t.Light = 300] = "Light", t[t.Normal = 400] = "Normal", t[t.Medium = 500] = "Medium", t[t.SemiBold = 600] = "SemiBold", t[t.Bold = 700] = "Bold", t[t.ExtraBold = 800] = "ExtraBold", t[t.Heavy = 900] = "Heavy";
  }(U || (U = {}));
  var q = /\s+/g;

  function K(t) {
    switch (t) {
      case U.Normal:
        return "normal";

      case U.Bold:
        return "bold";

      case U.Thin:
      case U.ExtraLight:
      case U.Light:
      case U.Medium:
      case U.SemiBold:
      case U.ExtraBold:
      case U.Heavy:
        return t.toString();

      default:
        return "";
    }
  }

  function G(t) {
    var e = [];
    if (t) for (var n = 0, r = t.length; n < r; ++n) {
      var o = t[n],
          i = q.test(o);
      e.push(i ? '"' + o + '"' : o);
    }
    return e.join(", ");
  }

  var J = function () {
    function t(t, e, n, r) {
      this.family = t, this.size = e, this.style = n, this.weight = r;
    }

    return t.fromObject = function (e) {
      return new t(e.family || null, e.size ? V.fromObject(e.size) : null, e.style ? function (t) {
        switch (t) {
          case "normal":
            return H.Normal;

          case "italic":
            return H.Italic;

          default:
            throw new Error("Invalid font style '" + t + "' specified");
        }
      }(e.style) : null, void 0 !== e.weight && null !== e.weight ? e.weight : null);
    }, t.prototype.toString = function () {
      if (this.style !== H.Normal && this.weight !== U.Normal || this.style === H.Normal && this.weight === U.Normal) {
        var t = [];
        return this.style === H.Normal ? t.push("normal") : (this.style && t.push(this.style), this.weight && t.push(K(this.weight))), this.size && t.push(this.size.toString()), this.family && t.push(G(this.family)), t.join(" ");
      }

      return function (t) {
        var e,
            n = [],
            r = G(t.family);
        return r.length > 0 && n.push("font-family: " + r + ";"), (r = t.size ? t.size.toString() : "").length > 0 && n.push("font-size: " + r + ";"), (r = (e = t.style) ? e.toString() : "").length > 0 && n.push("font-style: " + r + ";"), (r = K(t.weight)).length > 0 && n.push("font-weight: " + r + ";"), n.join(" ");
      }(this);
    }, t;
  }(),
      Q = function () {
    function t(t, e, n) {
      var r = new Map();
      null !== t && t.forEach(function (t, o) {
        if ("palette" === t.type) {
          var i = t;

          switch (i.paletteType) {
            case "cat":
              r.set(o, new O(i, e, n));
              break;

            case "cont":
              r.set(o, new E(i, e, n));
          }
        }
      }), this.source = t, this.palettes = r;
    }

    return t.prototype.get = function (t) {
      return this._getValue(t, !1);
    }, t.prototype.peek = function (t) {
      return this._getValue(t, !0);
    }, t.prototype._getValue = function (t, e) {
      var n = this.source && this.source.get(t);
      if (!n) return null;

      switch (n.type) {
        case "string":
        case "number":
        case "boolean":
        case "enum":
          return e ? n.peek : n.value;

        case "length":
          var r = e ? n.peek : n.value;
          return r ? V.fromObject(r) : null;

        case "font":
          var o = e ? n.peek : n.value;
          return o ? J.fromObject(o) : null;

        case "color":
          var i = e ? n.peek : n.value;
          return i ? C.fromObject(i) : null;

        case "palette":
          return this.palettes.get(t) || null;

        default:
          return null;
      }
    }, t.prototype.isActive = function (t) {
      var e = this.source && this.source.get(t);
      return !!e && e.active;
    }, t.prototype.setActive = function (t, e) {
      var n = this.source && this.source.get(t);
      n && n.setActive(e);
    }, t.prototype.isDirty = function (t) {
      var e = this.source && this.source.get(t);
      return !!e && e.dirty;
    }, t;
  }();

  var W = setTimeout;

  function X(t) {
    return Boolean(t && void 0 !== t.length);
  }

  function Y() {}

  function Z(t) {
    if (!(this instanceof Z)) throw new TypeError("Promises must be constructed via new");
    if ("function" != typeof t) throw new TypeError("not a function");
    this._state = 0, this._handled = !1, this._value = void 0, this._deferreds = [], ot(t, this);
  }

  function $(t, e) {
    for (; 3 === t._state;) {
      t = t._value;
    }

    0 !== t._state ? (t._handled = !0, Z._immediateFn(function () {
      var n = 1 === t._state ? e.onFulfilled : e.onRejected;

      if (null !== n) {
        var r;

        try {
          r = n(t._value);
        } catch (t) {
          return void et(e.promise, t);
        }

        tt(e.promise, r);
      } else (1 === t._state ? tt : et)(e.promise, t._value);
    })) : t._deferreds.push(e);
  }

  function tt(t, e) {
    try {
      if (e === t) throw new TypeError("A promise cannot be resolved with itself.");

      if (e && ("object" == _typeof(e) || "function" == typeof e)) {
        var n = e.then;
        if (e instanceof Z) return t._state = 3, t._value = e, void nt(t);
        if ("function" == typeof n) return void ot((r = n, o = e, function () {
          r.apply(o, arguments);
        }), t);
      }

      t._state = 1, t._value = e, nt(t);
    } catch (e) {
      et(t, e);
    }

    var r, o;
  }

  function et(t, e) {
    t._state = 2, t._value = e, nt(t);
  }

  function nt(t) {
    2 === t._state && 0 === t._deferreds.length && Z._immediateFn(function () {
      t._handled || Z._unhandledRejectionFn(t._value);
    });

    for (var e = 0, n = t._deferreds.length; e < n; e++) {
      $(t, t._deferreds[e]);
    }

    t._deferreds = null;
  }

  function rt(t, e, n) {
    this.onFulfilled = "function" == typeof t ? t : null, this.onRejected = "function" == typeof e ? e : null, this.promise = n;
  }

  function ot(t, e) {
    var n = !1;

    try {
      t(function (t) {
        n || (n = !0, tt(e, t));
      }, function (t) {
        n || (n = !0, et(e, t));
      });
    } catch (t) {
      if (n) return;
      n = !0, et(e, t);
    }
  }

  Z.prototype["catch"] = function (t) {
    return this.then(null, t);
  }, Z.prototype.then = function (t, e) {
    var n = new this.constructor(Y);
    return $(this, new rt(t, e, n)), n;
  }, Z.prototype["finally"] = function (t) {
    var e = this.constructor;
    return this.then(function (n) {
      return e.resolve(t()).then(function () {
        return n;
      });
    }, function (n) {
      return e.resolve(t()).then(function () {
        return e.reject(n);
      });
    });
  }, Z.all = function (t) {
    return new Z(function (e, n) {
      if (!X(t)) return n(new TypeError("Promise.all accepts an array"));
      var r = Array.prototype.slice.call(t);
      if (0 === r.length) return e([]);
      var o = r.length;

      function i(t, u) {
        try {
          if (u && ("object" == _typeof(u) || "function" == typeof u)) {
            var s = u.then;
            if ("function" == typeof s) return void s.call(u, function (e) {
              i(t, e);
            }, n);
          }

          r[t] = u, 0 == --o && e(r);
        } catch (t) {
          n(t);
        }
      }

      for (var u = 0; u < r.length; u++) {
        i(u, r[u]);
      }
    });
  }, Z.resolve = function (t) {
    return t && "object" == _typeof(t) && t.constructor === Z ? t : new Z(function (e) {
      e(t);
    });
  }, Z.reject = function (t) {
    return new Z(function (e, n) {
      n(t);
    });
  }, Z.race = function (t) {
    return new Z(function (e, n) {
      if (!X(t)) return n(new TypeError("Promise.race accepts an array"));

      for (var r = 0, o = t.length; r < o; r++) {
        Z.resolve(t[r]).then(e, n);
      }
    });
  }, Z._immediateFn = "function" == typeof setImmediate && function (t) {
    setImmediate(t);
  } || function (t) {
    W(t, 0);
  }, Z._unhandledRejectionFn = function (t) {
    "undefined" != typeof console && console && console.warn("Possible Unhandled Promise Rejection:", t);
  };

  var it = function it(t, e, n, r) {
    this.data = t, this.decorations = e, this.properties = n, this.size = r;
  },
      ut = function ut(t, e, n, r, o) {
    this.reason = t, this.data = e, this.node = n, this.props = r, this.locale = o;
  };

  var st = function () {
    function n() {
      this._data = null, this._elem = null, this._nls = null, this._locale = "en-us", this._slotResolver = this.getSlotForPalette.bind(this), this.properties = new Q(null, null, this._slotResolver), this.meta = new k();
    }

    return n.prototype.init = function (t, e) {
      var n = this,
          r = t.surface.appendChild(document.createElement("div"));
      r.setAttribute("style", "left: 0; top: 0; width: 100%; height: 100%; position: absolute"), r.setAttribute("data-charttype", "custom-viz"), this.properties = new Q(t.properties, t.dataContext, this._slotResolver), this._nls = t.nls, this._locale = t.locale, Z.resolve(this.create(r)).then(function (o) {
        n._elem = o || r, t.properties.forEach(function (t, e) {
          return n.updateProperty(e, t.value);
        }), e.complete();
      })["catch"](function (t) {
        e.fail(t);
      });
    }, n.prototype.destroy = function () {}, n.prototype.getPropertyApi = function () {
      return null;
    }, n.prototype.setData = function (t) {
      t && t.dataSets && t.dataSets[0] ? this._data = b(t.dataSets[0]) : this._data = null;
    }, n.prototype.setProperty = function (t, e) {
      this.updateProperty(t, this.properties.peek(t));
    }, n.prototype.getBlockingRequests = function () {
      return null;
    }, n.prototype.render = function (t, e, n) {
      if (!this._elem) return n.complete(null, null, null), null;
      if (!(e.data || e.decorations || e.properties || e.size)) return n.complete(null, null, null), null;

      try {
        var r = this.update(new ut(function (t) {
          return new it(t.data, t.decorations, t.properties, t.size);
        }(e), this._data, this._elem, this.properties, this._locale));
        Z.resolve(r).then(function () {
          return n.complete(null, null, null);
        })["catch"](n.error);
      } catch (t) {
        n.error(t);
      }

      return null;
    }, n.prototype.getEncodings = function () {
      return this._data ? this.updateLegend(this._data) : [];
    }, n.prototype.getCapabilities = function () {
      var t = [];
      return this.meta.slotLimits.forEach(function (n, r) {
        t.push(e.slotLimit(r, n));
      }), this.meta.dataLimit >= 0 && t.push(e.dataLimit(this.meta.dataLimit)), t;
    }, n.prototype.getInteractivity = function () {
      return null;
    }, n.prototype.getVisCoordinate = function (t, e) {
      return e;
    }, n.prototype.getRegionAtPoint = function (t, e) {
      return null;
    }, n.prototype.getItemsAtPoint = function (t, e, n) {
      if (!t || !t.hasOwnProperty("x") || !t.hasOwnProperty("y")) return null;
      var r = t,
          o = document.elementFromPoint(r.x, r.y),
          i = this.hitTest(o, r, e);
      return i && i.source ? [i.source] : [];
    }, n.prototype.getItemsInPolygon = function (t, e) {
      return [];
    }, n.prototype.getAxisItemsAtPoint = function (t, e, n) {
      return [];
    }, n.prototype.getState = function () {
      return null;
    }, n.prototype.setState = function (t) {}, n.prototype.loadCss = function (t) {
      var e = document.createElement("link");
      e.type = "text/css", e.rel = "stylesheet", e.href = this.toUrl(t), document.getElementsByTagName("head")[0].appendChild(e);
    }, n.prototype.toUrl = function (e) {
      return requirejs.toUrl(e);
    }, n.prototype.update = function (t) {}, n.prototype.create = function (t) {}, n.prototype.updateProperty = function (t, e) {}, n.prototype.updateLegend = function (t) {
      return z(t, this.properties, this.meta, this._slotResolver);
    }, n.prototype.getSlotForPalette = function (t, e) {
      return null;
    }, n.prototype.hitTest = function (t, e, n) {
      var r = t && t.__data__;
      return r && r.source ? r : null;
    }, n.prototype.nls = function (t) {
      return this._nls && this._nls.get(t) || "";
    }, n;
  }();

  var CATEGORIES = 0,
      HIGH = 1,
      LOW = 2,
      OPEN = 3,
      CLOSE = 4;
  var margin = {
    left: 5,
    top: 15,
    right: 15,
    bottom: 5
  }; // Chart margins

  var darker = function darker(color) {
    return "rgba(".concat(0.7 * color.r, ",").concat(0.7 * color.g, ",").concat(0.7 * color.b, ",").concat(color.a, ")");
  };

  function removeCollidedText(_selection) {
    var quadtree = d3.quadtree().x(function (d) {
      return d.x;
    }).y(function (d) {
      return d.y;
    });
    var widthRadius = 0;
    var heightRadius = 0;
    var rect;
    var hasCollided = false;

    function visit(_node, _x1, _y1, _x2, _y2) {
      if (hasCollided) return true;
      if (_node.data === rect) return false; // Child node

      if (!_node.length) hasCollided = !(rect.right < _node.data.left || _node.data.right < rect.left || rect.bottom < _node.data.top || _node.data.bottom < rect.top);
      return !(rect.left < _x2 + widthRadius && rect.right > _x1 - widthRadius && rect.top < _y2 + heightRadius && rect.bottom > _y1 - heightRadius);
    }

    _selection.each(function () {
      rect = this.getBoundingClientRect();
      widthRadius = Math.max(widthRadius, rect.width);
      heightRadius = Math.max(heightRadius, rect.height);
      hasCollided = false;
      quadtree.visit(visit);

      if (!hasCollided) {
        quadtree.add(rect);
        this.collide = false;
      } else this.collide = true;
    });

    _selection.style("visibility", function () {
      return this.collide ? "hidden" : null;
    });
  }

  function createFontString(_font) {
    var fontString = "";
    if (!_font) return fontString;
    if (_font.family && _font.family.length) fontString += "font-family:" + _font.family.join(", ") + ";";
    if (_font.size) fontString += "font-size:" + _font.size + ";";
    if (_font.style) fontString += "font-style:" + _font.style + ";";
    if (_font.weight) fontString += "font-weight:" + _font.weight + ";";
    return fontString;
  }

  var _default = /*#__PURE__*/function (_RenderBase) {
    _inherits(_default, _RenderBase);

    var _super = _createSuper(_default);

    function _default() {
      var _this;

      _classCallCheck(this, _default);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));

      _defineProperty(_assertThisInitialized(_this), "_bodyPositiveColor", null);

      _defineProperty(_assertThisInitialized(_this), "_bodyNegativeColor", null);

      _defineProperty(_assertThisInitialized(_this), "_bodyBorderPositiveColor", null);

      _defineProperty(_assertThisInitialized(_this), "_bodyBorderNegativeColor", null);

      return _this;
    }

    _createClass(_default, [{
      key: "create",
      // Create is called during initialization
      value: function create(_node) {
        // Ensure a repeating background image.
        _node.style.backgroundRepeat = "repeat"; // Create a svg node

        var svg = d3.select(_node).append("svg").style("position", "absolute").attr("width", "100%").attr("height", "100%").append("g").attr("class", "container");
        svg.append("g").attr("class", "axes");
        svg.append("g").attr("class", "chartContent"); // Return the root node so it can be used in `update`.

        return _node;
      }
    }, {
      key: "updateLegend",
      value: function updateLegend(_data) {
        var encodings = [];

        if (_data.cols[OPEN].mapped && _data.cols[CLOSE].mapped) {
          // NOTE: The only difference between the two colors is when the opening and closing values are opposite.
          //       Therefore, we can't provide a classname for highlighting certain data points
          var equalBodyColors = this._bodyPositiveColor && this._bodyNegativeColor && this._bodyPositiveColor.toString() === this._bodyNegativeColor.toString();

          var positiveColor = equalBodyColors ? this._bodyBorderPositiveColor : this._bodyPositiveColor;
          var negativeColor = equalBodyColors ? this._bodyBorderNegativeColor : this._bodyNegativeColor; // NOTE: to enable legend title interactivity, we need to set encoding.ref to a CatDataItem( itemClasses, tuples )

          var encoding = new L("color", null, "Candle", null, null);
          encoding.entries.push(new F("Positive", positiveColor, null, true, false, null));
          encoding.entries.push(new F("Negative", negativeColor, null, true, false, null));
          encodings.push(encoding);
        }

        return encodings;
      } // Update is called during new data, property change, resizing, etc.

    }, {
      key: "update",
      value: function update(_info) {
        var node = _info.node;
        var container = d3.select(node).select(".container"); // if no data is mapped, clean up and exit

        if (!_info.data) {
          container.select(".chartContent").selectAll("*").remove();
          container.select(".axes").selectAll("*").remove();
          return;
        }

        var rows = _info.data.rows;
        var clientHeight = node.clientHeight,
            clientWidth = node.clientWidth;
        var content = {
          width: clientWidth - margin.left - margin.right,
          height: clientHeight - margin.top - margin.bottom
        };
        container.attr("transform", "translate(".concat(margin.left, ", ").concat(margin.top, ")"));
        var hasBodies = _info.data && _info.data.cols[CLOSE].mapped && _info.data.cols[OPEN].mapped;
        var maxDomain = Math.max(_info.data.cols[HIGH].domain.max, _info.data.cols[LOW].domain.max);
        var minDomain = Math.min(_info.data.cols[HIGH].domain.min, _info.data.cols[LOW].domain.min);

        if (hasBodies) {
          // Include open and close slots
          maxDomain = Math.max(maxDomain, _info.data.cols[OPEN].domain.max, _info.data.cols[CLOSE].domain.max);
          minDomain = Math.min(minDomain, _info.data.cols[OPEN].domain.min, _info.data.cols[CLOSE].domain.min);
        }

        var categories = _info.data.cols[CATEGORIES].tuples.map(function (_t) {
          return _t.key;
        });

        var xScale = d3.scaleBand().domain(categories).range([0, content.width]).padding(0.05);
        var yScale = d3.scaleLinear().domain([minDomain, maxDomain]).range([content.height, 0]).nice();
        var axisLeft = d3.axisLeft(yScale).tickFormat(function (val) {
          return _info.data.cols[HIGH].format(val.valueOf(), u.label);
        });
        var axisBottom = d3.axisBottom(xScale).tickFormat(function (_, idx) {
          return _info.data.cols[CATEGORIES].tuples[idx].caption;
        });
        var props = _info.props;
        var axisLabelFont = props.get("axis.labels.font");
        var axisLabelColor = props.get("axis.labels.color");
        var shadowWidth = props.get("shadow.width");
        var bodyShape = props.get("body.shape");
        var bodyPadding = props.get("body.relativePadding") / 100;
        var bodyWidth = xScale.bandwidth() * (1 - bodyPadding);
        var bodyPositiveColor = this._bodyPositiveColor = props.get("body.positive.color");
        var bodyNegativeColor = this._bodyNegativeColor = props.get("body.negative.color");
        var bodyBorderPositiveColor = this._bodyBorderPositiveColor = props.get("body.border.positive.color");
        var bodyBorderNegativeColor = this._bodyBorderNegativeColor = props.get("body.border.negative.color");
        var shadowPositiveColor = props.get("shadow.positive.color");
        var shadowNegativeColor = props.get("shadow.negative.color");
        var td = props.get("transition-duration");
        var transition = d3.transition().duration(td);
        var hasSelection = rows.some(function (r) {
          return r.selected;
        }); // Create left & bottom axis

        var axisLeftSel = container.select(".axes").selectAll(".axisLeft").data([null]).join("g").attr("class", "axisLeft").attr("style", createFontString(axisLabelFont)).call(axisLeft);
        var axisBottomSel = container.select(".axes").selectAll(".axisBottom").data([null]).join("g").attr("class", "axisBottom").attr("style", createFontString(axisLabelFont)).call(axisBottom);
        var axisLeftWidth = axisLeftSel.node() ? axisLeftSel.node().getBBox().width : 0;
        var axisBottomHeight = axisBottomSel.node() ? axisBottomSel.node().getBBox().height : 0;
        var yAxisWidth = axisLeftWidth + 4; // X axis title

        var xAxisLabelHeight = axisBottomSel.select(".tick ").node() ? axisBottomSel.select(".tick ").node().getBBox().height : 0;
        axisBottomSel.selectAll(".axisTitle").data([null]).join("text").attr("class", "axisTitle").attr("x", (content.width - yAxisWidth) * 0.5).attr("y", xAxisLabelHeight + 15).text(_info.data.cols[CATEGORIES].caption); // NOTE: We use the same font for title as used for the ticks, except in bold state.
        //       When overridden, it will take the weight of the given font

        container.selectAll(".axisTitle").attr("style", createFontString(axisLabelFont)).style("font-weight", "bold").style("fill", axisLabelColor);
        var contentSize = {
          left: axisLeftWidth,
          width: content.width - axisLeftWidth,
          height: content.height - axisBottomHeight
        }; // Update scales

        xScale.range([0, contentSize.width]);
        yScale.range([contentSize.height, 0]); // Update axis elements

        axisLeftSel.attr("transform", "translate(".concat(contentSize.left, ", 0)")).call(axisLeft);
        axisBottomSel.attr("transform", "translate(".concat(contentSize.left, ", ").concat(contentSize.height, ")")).call(axisBottom);
        container.selectAll(".tick text").attr("fill", axisLabelColor);

        function updateCandle(_d) {
          var isNegative = _d.value(OPEN) < _d.value(CLOSE);

          var bodyColor = isNegative ? bodyNegativeColor : bodyPositiveColor;
          var bodyBorderColor = isNegative ? bodyBorderNegativeColor : bodyBorderPositiveColor;
          var shadowColor = isNegative ? shadowNegativeColor : shadowPositiveColor; // Emphasis on this element

          var zenithDataItem = _d.selected || _d.highlighted; // Faded out variant of this element

          var nadirDataItem = hasSelection && !zenithDataItem;
          var y1 = Math.min(yScale(_d.value(LOW)), yScale(_d.value(HIGH)));
          var y2 = Math.max(yScale(_d.value(LOW)), yScale(_d.value(HIGH)));
          var y4;
          var g = d3.select(this);

          if (hasBodies) {
            // If we have to draw the body, the line is interrupted (it consists of two lines)
            y4 = y2;
            y2 = Math.min(yScale(_d.value(OPEN)), yScale(_d.value(CLOSE)));
            g.select("line.bottom").attr("visibility", null);
          } else {
            g.select("line.bottom").attr("visibility", "hidden");
          }

          g.select("line.top").attr("x1", 0).attr("x2", 0).attr("stroke-width", zenithDataItem ? shadowWidth + 1 : shadowWidth).attr("stroke", shadowColor).attr("opacity", nadirDataItem ? 0.4 : 1).transition(transition).attr("y1", y1).attr("y2", y2);
          var body = g.select("rect");

          if (hasBodies) {
            var height = Math.abs(yScale(_d.value(OPEN)) - yScale(_d.value(CLOSE)));
            var y3 = Math.max(yScale(_d.value(OPEN)), yScale(_d.value(CLOSE)));

            var _g = d3.select(this);

            _g.select("line.bottom").attr("x1", 0).attr("x2", 0).attr("stroke-width", zenithDataItem ? shadowWidth + 1 : shadowWidth).attr("stroke", shadowColor).attr("opacity", nadirDataItem ? 0.4 : 1).transition(transition).attr("y1", y3).attr("y2", y4);

            body.attr("visibility", null).attr("stroke-width", zenithDataItem ? 3 : 2).attr("stroke", zenithDataItem ? darker(bodyBorderColor) : bodyBorderColor).attr("fill", bodyColor).attr("opacity", nadirDataItem ? 0.4 : 1).transition(transition).attr("transform", "translate(".concat(-bodyWidth * 0.5, ", ").concat(y2, ")")).attr("height", height).attr("width", bodyWidth).attr("rx", bodyShape);
          } else {
            body.attr("visibility", "hidden");
          }
        }

        function createCandle(_d) {
          var g = d3.select(this);
          g.append("line").attr("class", "top");
          g.append("line").attr("class", "bottom"); // Only draw body if close & open slot is mapped

          g.append("rect");
          updateCandle(_d);
        } // Draw without axes


        var candles = container.select(".chartContent").attr("transform", "translate(".concat(contentSize.left, ", 0)")).selectAll(".candle").data(rows, function (_d) {
          return _d.key;
        }).join(function (enter) {
          return enter.append("g").attr("transform", function (d) {
            return "translate(".concat(xScale(d.tuple(CATEGORIES).key) + xScale.bandwidth() * 0.5, ", 0)");
          }).each(createCandle);
        }).attr("class", "candle").each(updateCandle);
        candles.transition(transition).attr("transform", function (d) {
          return "translate(".concat(xScale(d.tuple(CATEGORIES).key) + xScale.bandwidth() * 0.5, ", 0)");
        });
        removeCollidedText(container.select(".axes").selectAll("text"));
      }
    }]);

    return _default;
  }(st);

  return _default;

});
